searchNodes=[{"doc":"Namespace and module for crypto-related functionality.For low-level functionality, see Plug.Crypto.KeyGenerator, Plug.Crypto.MessageEncryptor, and Plug.Crypto.MessageVerifier.","ref":"Plug.Crypto.html","title":"Plug.Crypto","type":"module"},{"doc":"Decrypts the original data from the token and verifies its integrity.Options:max_age - verifies the token only if it has been generated &quot;max age&quot; ago in seconds. A reasonable value is 1 day (86400 seconds):key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256","ref":"Plug.Crypto.html#decrypt/4","title":"Plug.Crypto.decrypt/4","type":"function"},{"doc":"Encodes, encrypts, and signs data into a token you can send to clients.Options:key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256:signed_at - set the timestamp of the token in seconds. Defaults to System.system_time(:second):max_age - the default maximum age of the token. Defaults to 86400 seconds (1 day) and it may be overridden on decrypt/4.","ref":"Plug.Crypto.html#encrypt/4","title":"Plug.Crypto.encrypt/4","type":"function"},{"doc":"Masks the token on the left with the token on the right.Both tokens are required to have the same size.","ref":"Plug.Crypto.html#mask/2","title":"Plug.Crypto.mask/2","type":"function"},{"doc":"Compares the two binaries (one being masked) in constant-time to avoid timing attacks.It is assumed the right token is masked according to the given mask.","ref":"Plug.Crypto.html#masked_compare/3","title":"Plug.Crypto.masked_compare/3","type":"function"},{"doc":"A restricted version of :erlang.binary_to_term/2 that forbids executable terms, such as anonymous functions.The opts are given to the underlying :erlang.binary_to_term/2 call, with an empty list as a default.By default this function does not restrict atoms, as an atom interned in one node may not yet have been interned on another (except for releases, which preload all code).If you want to avoid atoms from being created, then you can pass [:safe] as options, as that will also enable the safety mechanisms from :erlang.binary_to_term/2 itself.","ref":"Plug.Crypto.html#non_executable_binary_to_term/2","title":"Plug.Crypto.non_executable_binary_to_term/2","type":"function"},{"doc":"Prunes the stacktrace to remove any argument trace.This is useful when working with functions that receives secrets and we want to make sure those secrets do not leak on error messages.","ref":"Plug.Crypto.html#prune_args_from_stacktrace/1","title":"Plug.Crypto.prune_args_from_stacktrace/1","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks.See: http://codahale.com/a-lesson-in-timing-attacks/","ref":"Plug.Crypto.html#secure_compare/2","title":"Plug.Crypto.secure_compare/2","type":"function"},{"doc":"Encodes and signs data into a token you can send to clients.Plug.Crypto.sign(conn.secret_key_base, &quot;user-secret&quot;, {:elixir, :terms})Options:key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256:signed_at - set the timestamp of the token in seconds. Defaults to System.system_time(:second):max_age - the default maximum age of the token. Defaults to 86400 seconds (1 day) and it may be overridden on verify/4.","ref":"Plug.Crypto.html#sign/4","title":"Plug.Crypto.sign/4","type":"function"},{"doc":"Decodes the original data from the token and verifies its integrity.ExamplesIn this scenario we will create a token, sign it, then provide it to a client application. The client will then use this token to authenticate requests for resources from the server. See Plug.Crypto summary for more info about creating tokens.iex&gt; user_id = 99 iex&gt; secret = &quot;kjoy3o1zeidquwy1398juxzldjlksahdk3&quot; iex&gt; user_salt = &quot;user salt&quot; iex&gt; token = Plug.Crypto.sign(secret, user_salt, user_id)The mechanism for passing the token to the client is typically through a cookie, a JSON response body, or HTTP header. For now, assume the client has received a token it can use to validate requests for protected resources.When the server receives a request, it can use verify/4 to determine if it should provide the requested resources to the client:iex&gt; Plug.Crypto.verify(secret, user_salt, token, max_age: 86400) {:ok, 99}In this example, we know the client sent a valid token because verify/4 returned a tuple of type {:ok, user_id}. The server can now proceed with the request.However, if the client had sent an expired or otherwise invalid token verify/4 would have returned an error instead:iex&gt; Plug.Crypto.verify(secret, user_salt, expired, max_age: 86400) {:error, :expired} iex&gt; Plug.Crypto.verify(secret, user_salt, invalid, max_age: 86400) {:error, :invalid}Options:max_age - verifies the token only if it has been generated &quot;max age&quot; ago in seconds. Defaults to the max age signed in the token (86400):key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256","ref":"Plug.Crypto.html#verify/4","title":"Plug.Crypto.verify/4","type":"function"},{"doc":"","ref":"Plug.Crypto.Application.html","title":"Plug.Crypto.Application","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Plug.Crypto.Application.html#start/2","title":"Plug.Crypto.Application.start/2","type":"function"},{"doc":"KeyGenerator implements PBKDF2 (Password-Based Key Derivation Function 2), part of PKCS #5 v2.0 (Password-Based Cryptography Specification).It can be used to derive a number of keys for various purposes from a given secret. This lets applications have a single secure secret, but avoid reusing that key in multiple incompatible contexts.The returned key is a binary. You may invoke functions in the Base module, such as Base.url_encode64/2, to convert this binary into a textual representation.See http://tools.ietf.org/html/rfc2898#section-5.2","ref":"Plug.Crypto.KeyGenerator.html","title":"Plug.Crypto.KeyGenerator","type":"module"},{"doc":"Returns a derived key suitable for use.Options:iterations - defaults to 1000 (increase to at least 2^16 if used for passwords);:length - a length in octets for the derived key. Defaults to 32;:digest - an hmac function to use as the pseudo-random function. Defaults to :sha256;:cache - an ETS table name to be used as cache. Only use an ETS table as cache if the secret and salt is a bound set of values. For example: :ets.new(:your_name, [:named_table, :public, read_concurrency: true])","ref":"Plug.Crypto.KeyGenerator.html#generate/3","title":"Plug.Crypto.KeyGenerator.generate/3","type":"function"},{"doc":"MessageEncryptor is a simple way to encrypt values which get stored somewhere you don't trust.The encrypted key, initialization vector, cipher text, and cipher tag are base64url encoded and returned to you.This can be used in situations similar to the Plug.Crypto.MessageVerifier, but where you don't want users to be able to determine the value of the payload.The current algorithm used is AES-GCM-128.Exampleiex&gt; secret_key_base = &quot;072d1e0157c008193fe48a670cce031faa4e...&quot; ...&gt; encrypted_cookie_salt = &quot;encrypted cookie&quot; ...&gt; encrypted_signed_cookie_salt = &quot;signed encrypted cookie&quot; ...&gt; ...&gt; secret = KeyGenerator.generate(secret_key_base, encrypted_cookie_salt) ...&gt; sign_secret = KeyGenerator.generate(secret_key_base, encrypted_signed_cookie_salt) ...&gt; ...&gt; data = &quot;José&quot; ...&gt; encrypted = MessageEncryptor.encrypt(data, secret, sign_secret) ...&gt; MessageEncryptor.decrypt(encrypted, secret, sign_secret) {:ok, &quot;José&quot;}","ref":"Plug.Crypto.MessageEncryptor.html","title":"Plug.Crypto.MessageEncryptor","type":"module"},{"doc":"Decrypts a message using authenticated encryption.","ref":"Plug.Crypto.MessageEncryptor.html#decrypt/3","title":"Plug.Crypto.MessageEncryptor.decrypt/3","type":"function"},{"doc":"Encrypts a message using authenticated encryption.","ref":"Plug.Crypto.MessageEncryptor.html#encrypt/3","title":"Plug.Crypto.MessageEncryptor.encrypt/3","type":"function"},{"doc":"MessageVerifier makes it easy to generate and verify messages which are signed to prevent tampering.For example, the cookie store uses this verifier to send data to the client. The data can be read by the client, but cannot be tampered with.The message and its verification are base64url encoded and returned to you.The current algorithm used is HMAC-SHA, with SHA256, SHA384, and SHA512 as supported digest types.","ref":"Plug.Crypto.MessageVerifier.html","title":"Plug.Crypto.MessageVerifier","type":"module"},{"doc":"Signs a message according to the given secret.","ref":"Plug.Crypto.MessageVerifier.html#sign/3","title":"Plug.Crypto.MessageVerifier.sign/3","type":"function"},{"doc":"Decodes and verifies the encoded binary was not tampered with.","ref":"Plug.Crypto.MessageVerifier.html#verify/2","title":"Plug.Crypto.MessageVerifier.verify/2","type":"function"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Add support for Erlang/OTP 24","ref":"changelog.html#v1-2-1-2021-02-17","title":"Changelog - v1.2.1 (2021-02-17)","type":"extras"},{"doc":"Update Elixir requirement to Elixir 1.7+.Fixed a bug that allowed to sign and encrypt stuff with nil secret key base and salt.","ref":"changelog.html#v1-2-0-2020-10-07","title":"Changelog - v1.2.0 (2020-10-07)","type":"extras"},{"doc":"Do not key derive empty salts (default to no salt instead).","ref":"changelog.html#v1-1-2-2020-02-16","title":"Changelog - v1.1.2 (2020-02-16)","type":"extras"},{"doc":"Do not expose encryption with salt API.Allow default :max_age to be set when signing/encrypting.","ref":"changelog.html#v1-1-1-2020-02-14","title":"Changelog - v1.1.1 (2020-02-14)","type":"extras"},{"doc":"Add high-level Plug.Crypto.sign/verify and Plug.Crypto.encrypt/decrypt.","ref":"changelog.html#v1-1-0-2020-02-11","title":"Changelog - v1.1.0 (2020-02-11)","type":"extras"},{"doc":"Split up the plug_crypto project from Plug as per elixir-lang/plug#766.","ref":"changelog.html#v1-0-0-2018-10-03","title":"Changelog - v1.0.0 (2018-10-03)","type":"extras"}]